<?php

require_once 'model/usuario.entidad.php';
require_once 'model/usuario.model.php';

require_once 'model/clientes.entidad.php';
require_once 'model/clientes.model.php';
require_once 'model/contrato.entidad.php';
require_once 'model/contrato.model.php';
require_once 'model/detalle_contrato.model.php';

class ContratoController extends helpers {

    private $usuario_model;

    private $cliente_model;
    private $contrato_model;
    private $detalle_contrato_model;

    public function __CONSTRUCT() {
        $this->usuario_model = new UsuarioModel();

        $this->cliente_model = new ClientesModel();
        $this->contrato_model = new ContratoModel();
        $this->detalle_contrato_model = new DetalleContratoModel();
    }

    public function Index() {
        $contratos = $this->contrato_model->Listar();
        require_once 'view/header.php';
        require_once 'view/webforms/wfacontrato.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarContrato() {
        $clientes = $this->cliente_model->Listar();
        require_once 'view/webforms/wfacontratoa.php';
    }

    public function FrmEditarContrato() {
        $contrato = $this->contrato_model->Buscar($_POST['Contrato_Id']);
        $clientes = $this->cliente_model->Listar();
        $lista_detalle = $this->detalle_contrato_model->Buscar($_POST['Contrato_Id']);

        foreach ($contrato as $r):
            require_once 'view/webforms/wfacontratoa.php';
        endforeach;
    }

    public function MostrarContrato() {
        $contrato = $this->contrato_model->Buscar($_POST['Contrato_Id']);
        foreach($contrato as $r):
            echo "
                <tbody>
                    <tr>
                        <td>Número Contrato</td>
                        <td>".$r->__get('sConNumero')."</td>
                    </tr>
                    <tr>
                        <td>Fecha</td>
                        <td>".$r->__get('dConFecha')."</td>
                    </tr>
                    <tr>
                        <td>Cliente</td>
                        <td>".$r->__get('sCliNombre')."</td>
                    </tr>
                    <tr>
                        <td>Fecha de Inicio</td>
                        <td>".$r->__get('dConFechaInicio')."</td>
                    </tr>
                    <tr>
                        <td>Fecha de Término</td>
                        <td>".$r->__get('dConFechaTermino') ."</td>
                    </tr>
                    <tr>
                        <td>Periodo de Alquiler</td>
                        <td>".$r->__get('sConPeriodoAlquiler')."</td>
                    </tr>
                    <tr>
                        <td>Ubicación</td>
                        <td>".$r->__get('sConUbicacion')."</td>
                    </tr>
                    ";
                $detalle_contrato = $this->detalle_contrato_model->Buscar($_POST['Contrato_Id']);
                if (!empty($detalle_contrato)) {
                    echo '
                        <tr>
                            <td colspan="2">
                                <table class="table table-hover">
                                    <thead>
                                        <th>Código</th>
                                        <th>Serie</th>
                                        <th>Tipo</th>
                                        <th>Sucursal</th>
                                        <th>Ubicación</th>
                                        <th>Horas operación	</th>
                                    </thead>';
                                    foreach($detalle_contrato as $dc):
                                        echo '
                                            <tr>
                                                <td>'. $dc->__get('sDetConCodigo') .'</td>
                                                <td>'. $dc->__get('sDetConSerie') .'</td>
                                                <td>'. $dc->__get('sDetConTipo') .'</td>
                                                <td>'. $dc->__get('sDetConSucursal') .'</td>
                                                <td>'. $dc->__get('sDetConUbicacion') .'</td>
                                                <td>'. $dc->__get('sDetConHorasOperacion') .'</td>
                                            </tr>
                                        ';
                                    endforeach;
                    echo        '</table>
                            </td>
                        </tr>
                    ';
                }
                "</tbody>
            ";
        endforeach;
    }

    public function VerificarNumeroContrato() {
        $id = $_POST['Contrato_Id'];
        $sConNumero = $_POST['sConNumero'];
        $existe = $this->contrato_model->NumeroContratoExiste($id, $sConNumero);
        echo $existe ? '1' : '0';
    }
    

    public function GuardarContrato() {
        $contrato = new Contrato();
        $contrato->__SET('Contrato_Id', $_POST['Contrato_Id']);
        $contrato->__SET('sConNumero', $_POST['sConNumero']);
        $contrato->__SET('nConCliente_Id', $_POST['nConCliente_Id']);
        $contrato->__SET('dConFecha', $_POST['dConFecha']);
        $contrato->__SET('dConFechaInicio', $_POST['dConFechaInicio']);
        $contrato->__SET('dConFechaTermino', $_POST['dConFechaTermino']);
        $contrato->__SET('sConPeriodoAlquiler', $_POST['sConPeriodoAlquiler']);
        $contrato->__SET('sConSucursal', $_POST['sConSucursal']);
        $contrato->__SET('sConUbicacion', $_POST['sConUbicacion']);
        $contrato->__SET('nConUsuario_Id', $_SESSION['usu_codigo']);

        $_POST['Contrato_Id'] == 0 ? $Contrato_Id = $this->contrato_model->Guardar($contrato)
            : $this->contrato_model->Editar($contrato);
        
        // editar
        if ($_POST['Contrato_Id'] != 0) {
            // eliminar detalle
            $this->detalle_contrato_model->EliminarByContrato($_POST['Contrato_Id']);

            // crear detalle
            if (isset($_POST['dataDatos'])) {
                foreach($_POST['dataDatos'] as $r):
                    $detalle_contrato = new DetalleContrato();
                    $detalle_contrato->__SET('nContrato_Id', $contrato->__get('Contrato_Id'));
                    $detalle_contrato->__SET('sDetConCodigo', $r['sDetConCodigo']);
                    $detalle_contrato->__SET('sDetConSerie', $r['sDetConSerie']);
                    $detalle_contrato->__SET('sDetConTipo', $r['sDetConTipo']);
                    $detalle_contrato->__SET('sDetConUbicacion', $r['sDetConUbicacion']);
                    $detalle_contrato->__SET('sDetConHorasOperacion', $r['sDetConHorasOperacion']);
                    $detalle_contrato->__SET('sDetConSucursal', $r['sDetConSucursal']);
                    $this->contrato_model->CrearDetalleContrato($detalle_contrato);
                endforeach;
            }
        } else {
            // crear detalle
            if (isset($_POST['dataDatos'])) {
                foreach($_POST['dataDatos'] as $r):
                    $detalle_contrato = new DetalleContrato();
                    $detalle_contrato->__SET('nContrato_Id', $Contrato_Id);
                    $detalle_contrato->__SET('sDetConCodigo', $r['sDetConCodigo']);
                    $detalle_contrato->__SET('sDetConSerie', $r['sDetConSerie']);
                    $detalle_contrato->__SET('sDetConTipo', $r['sDetConTipo']);
                    $detalle_contrato->__SET('sDetConUbicacion', $r['sDetConUbicacion']);
                    $detalle_contrato->__SET('sDetConHorasOperacion', $r['sDetConHorasOperacion']);
                    $detalle_contrato->__SET('sDetConSucursal', $r['sDetConSucursal']);
                    $this->contrato_model->CrearDetalleContrato($detalle_contrato);
                endforeach;
            }
        }

        echo '<div class="alert alert-success prod" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <strong>Exito!</strong>, los datos fueron agregados correctamente.
            </div>';
    }

    public function EliminarContrato() {
        $contrato = new Contrato();
        $contrato->__SET('Contrato_Id', $_POST['idContrato']);
        $this->contrato_model->Eliminar($contrato);
        echo '<script type="text/javascript">window.location="?c=Contrato&a=Index";</script>';
    }

    public function ObtenerInfoContrato() {
        $equipo = $this->contrato_model->ObtenerInfoContrato($_POST['contrato_Id'], $_POST['psDetConCodigo']);
        echo json_encode($equipo);
    }

}

?>