<?php

require_once 'model/plantilla.entidad.php';
require_once 'model/plantilla.model.php';
require_once 'model/tarea.entidad.php';
require_once 'model/tarea.model.php';
require_once 'model/repuesto.entidad.php';
require_once 'model/repuesto.model.php';
require_once 'model/detalle_tarea.model.php';
require_once 'model/detalle_repuesto.model.php';

class PlantillaController extends helpers {

    private $plantilla_model;
    private $tarea_model;
    private $repuesto_model;
    private $detalle_tarea_model;
    private $detalle_repuesto_model;

    public function __CONSTRUCT() {
        $this->plantilla_model = new PlantillaModel();
        $this->tarea_model = new TareaModel();
        $this->repuesto_model = new RepuestoModel();
        $this->detalle_tarea_model = new DetalleTareaModel();
        $this->detalle_repuesto_model = new DetalleRepuestoModel();
    }

    public function Index() {
        $plantillas = $this->plantilla_model->Listar();
        require_once 'view/header.php';
        require_once 'view/webforms/wfaplantilla.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.catalogos').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarPlantilla() {
        $tareas = $this->tarea_model->Listar();
        $repuestos = $this->repuesto_model->Listar();
        require_once 'view/webforms/wfaplantillaa.php';
    }

    public function FrmEditarPlantilla() {
        $tareas = $this->tarea_model->Listar();
        $repuestos = $this->repuesto_model->Listar();
        $plantilla = $this->plantilla_model->Buscar($_POST['Plantilla_Id']);

        $lista_tareas = $this->detalle_tarea_model->Buscar($_POST['Plantilla_Id']);

        foreach ($plantilla as $r):
            require_once 'view/webforms/wfaplantillaa.php';
        endforeach;
    }

    public function MostrarPlantilla() {
        $plantilla = $this->plantilla_model->Buscar($_POST['Plantilla_Id']);        
        foreach ($plantilla as $r):
            $tipo = '';
            if ($r->__get('nPlanTipo') == 1) {
                $tipo = 'GE';
            }
            if ($r->__get('nPlanTipo') == 2) {
                $tipo = 'Torre';
            }
            if ($r->__get('nPlanTipo') == 3) {
                $tipo = 'Compresor';
            }
            if ($r->__get('nPlanTipo') == 4) {
                $tipo = 'Rodillo compactador';
            }
            echo "
                    <tr>
                        <td><strong>Plantilla</strong></td>
                        <td style='text-align: right;'>". $r->__get('sPlaNombre') ."</td>
                    </tr>
                    <tr>
                        <td><strong>Tipo</strong></td>
                        <td style='text-align: right;'>". $tipo ."</td>
                    </tr>
                ";
            $detalle_tarea = $this->detalle_tarea_model->Buscar($r->__get('Plantilla_Id'));
            if (!empty($detalle_tarea)) {
                echo '
                    <tr>
                        <td colspan="2">
                            <table class="table table-hover table-bordered">
                                <thead>
                                    <tr>
                                        <th>Tareas</th>
                                    </tr>
                                </thead>
                                <tbody>';
                                foreach($detalle_tarea as $dt):
                                    echo '
                                        <tr>
                                            <td>'. $dt->__get('sTarNombre') .'</td>
                                        </tr>
                                    ';
                                endforeach;
                echo            '</tbody>
                            </table>
                        </td>
                        
                    </tr>';   
            }
            $detalle_repuesto = $this->detalle_repuesto_model->Buscar($r->__get('Plantilla_Id'));
            if (!empty($detalle_repuesto)) {
                echo '
                    <tr>
                        <td colspan="2">
                            <table class="table table-hover table-bordered">
                                <thead>
                                    <tr>
                                        <th>Repuestos</th>
                                    </tr>
                                </thead>
                                <tbody>';
                                foreach($detalle_repuesto as $dt):
                                    echo '
                                        <tr>
                                            <td>'. $dt->__get('sRepNombre') .'</td>
                                        </tr>
                                    ';
                                endforeach;
                echo            '</tbody>
                            </table>
                        </td>
                        
                    </tr>';   
            }
        endforeach;
    }

    public function GuardarPlantilla() {
        $plantilla = new Plantilla();
        $plantilla->__set('Plantilla_Id', $_POST['Plantilla_Id']);
        $plantilla->__set('sPlaNombre', $_POST['sPlaNombre']);
        $plantilla->__set('nPlaUsuario_Id', $_SESSION['usu_codigo']);
        $plantilla->__set('nPlanTipo', $_POST['nPlaTipoId']);

        $_POST['Plantilla_Id'] == 0 ? $Plantilla_Id = $this->plantilla_model->Guardar($plantilla)
            : $this->plantilla_model->Editar($plantilla);

        // sí editar ==> eliminar el detalle tareas
        if ($_POST['Plantilla_Id'] != 0) {
            $this->detalle_tarea_model->EliminarByPlantilla($_POST['Plantilla_Id']);

            if (isset($_POST['dataTareas'])) {
                foreach($_POST['dataTareas'] as $t):
                    $detalle_tarea = new TareaDetalle();
                    $detalle_tarea->__set('nPlantilla_Id', $plantilla->__get('Plantilla_Id'));
                    $detalle_tarea->__set('nTarea_Id', (int)$t['Tarea_Id']);
                    $this->plantilla_model->CrearDetalleTarea($detalle_tarea);
                endforeach;
                
            }
        } else {
            // no editar ... crear

            if (isset($_POST['dataTareas'])) {
                foreach($_POST['dataTareas'] as $t):
                    $detalle_tarea = new TareaDetalle();
                    $detalle_tarea->__set('nPlantilla_Id', $Plantilla_Id);
                    $detalle_tarea->__set('nTarea_Id', (int)$t['Tarea_Id']);
                    $this->plantilla_model->CrearDetalleTarea($detalle_tarea);
                endforeach;
                
            }
        }

        echo '<div class="alert alert-success prod" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <strong>Exito!</strong>, los datos fueron agregados correctamente.
            </div>';
    }

    public function EliminarPlantilla() {
        $plantilla = new Plantilla();
        $plantilla->__SET('Plantilla_Id', $_POST['idPlantilla']);
        $this->plantilla_model->Eliminar($plantilla);
        echo '<script type="text/javascript">window.location="?c=Plantilla&a=Index";</script>';
    }

    // public function PDFUsuario() {
    //     $datos = $this->usuario_model->Buscar($_POST['idUsuario']);
    //     require_once 'view/webforms/PDF/usuario.php';
    // }

}

?>