<?php

use ICanBoogie\DateTime;

date_default_timezone_set('America/Lima');
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/reportes.entidad.php';
require_once 'model/reportes.model.php';
//CLASE CON FUNCIONES PARA REPORTE EN EXCEL
require_once 'ClassExcel.php';
//LIBRERIA DE EXCEL
require_once 'view/librerias/PHPExcel/PHPExcel.php';
/*em 20-01-21 */
require_once 'model/clientes.entidad.php';
require_once 'model/clientes.model.php';

class ReportesController extends ClassExcel
{

    private $reportes_model;
    private $prodserv_model;
    private $parametro_model;
    public  $tipomovimiento_model;
    private $objPHPExcel1;
    private $seguridad;
    private $clientes_mod; /*em 20-01-21 */

    public function __CONSTRUCT()
    {
        $this->reportes_model = new ReportesModel();
        $this->parametro_model = new ParametroModel();
        $this->clientes_model = new ClientesModel();
    }
    
    public function Certificadosxvencer()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $param = $parametro[1];
		$param = intval($param->sParValor);
        $reportes = $this->reportes_model->Certificadosxvencer();
        $_SESSION['reportes'] = $reportes;
        $hoy = date("Y-m-d"); 
        $array = [];
        /*em 14-01-20 */
        /*
        foreach ($reportes as $r) {
            $fin =  date('Y-m-d', strtotime($r->dInsFechaVencimiento)); 
            $inicio =  date('Y-m-d', strtotime($fin."- $param days")); 
            //if ( $hoy >= $inicio   &&  $hoy <= $fin ){
                $array[] = $r;
           // }	
        }
        $reportes = $array;
        */
        require_once 'view/header.php';
        require_once 'view/webreports/wfrcertificadosxvencer.php';
        // echo "<script type='text/javascript'>
        //                 $(document).ready(function (){
        //                     $('.reportes').addClass('active');
        //                 });
        //           </script>";
        require_once 'view/footer.php';
    }
    /* em 20-01-2020 usuarios */
    public function CertificadosxvencerCli()
    {

            $parametro = $this->parametro_model->ListarParametros();
            $param = $parametro[1];
            $param = intval($param->sParValor);
            
//            var_dump($_SESSION['usu_tipo']);
    
            $cliente = $this->clientes_model->Buscar($_SESSION['usu_Cli_Id']);
            $cliente = $cliente[0];
            $reportes = $this->reportes_model->CertificadosxvencerCli($cliente->sCliCodigo);
            $hoy = date("Y-m-d"); 
            $array = [];
            /*em 14-01-20 */
            /*
            foreach ($reportes as $r) {
               
                    $array[] = $r;
                }	
            }
            */
            $_SESSION['reportes'] = $reportes; // = $array;
            
            require_once 'view/headercliente.php';
            require_once 'view/webreports/wfrcertificadosxvencer.php';
            /*
            require_once 'view/webreports/wfrcertificadosxvencer.php';
            // echo "<script type='text/javascript'>
            //                 $(document).ready(function (){
            //                     $('.reportes').addClass('active');
            //                 });
            //           </script>";
            */
            require_once 'view/footer.php';
    }
    public function DescargarExcel()
    {

        $reporte = $_POST['nombre'];
        $titulos = json_decode($_POST['titulos'], true);
        $data = json_decode($_POST['data'], true);

        if (empty($fechaIni) && empty($fechaFin)) {
            $fechaIni = $fechaFin = date('Y-m-d');
        }
        if ($fechaIni === $fechaFin) {
            $fecha = sprintf('%s', date('d/m/Y', strtotime($fechaIni)));
        } else {
            $fecha = sprintf(
                '%s AL %s');
        }
        $this->GenerarExcel($reporte, $titulos, $data, $fecha);
    }

    private function GenerarExcel($reporte, array $titulos, array $data, $fecha = null, $filename = null)
    {

        if (empty($fecha)) {
            $fecha = date('d/m/Y');
        }
        if (empty($filename)) {
            $filename = sprintf('%s-%s.xlsx', $reporte, date('YmdHis'));
        }

        $desc = sprintf('Reporte de %s', $reporte);
        if (strlen($desc) >= 31) {
            $desc = $reporte;
        }
        $titulo = sprintf(
            "%s DEL %s ",
            strtoupper($reporte),
            $fecha
        );

        $letra = chr(64 + count($titulos));


        $this->SetPropiedades(["Hormiguita", $desc, $desc, $desc, $desc, $desc]);
        $this->SetTitulo("A1:{$letra}1", "A1", $titulo);
        $this->HeaderCell(2, $titulos);
        $this->Style_Titulo(count($data), range('A', $letra));

        $this->AjustarColumnCell(range('A', $letra));

        $this->Add_Cell_rptVentaDetallado(3, $data, range('A', $letra));

        $this->Download($filename);
    }

    /*em 14-01-2021*/
    public function excel(){
        $objPHPExcel = new PHPExcel();
        $styleArray = array(
            'font'  => array(
                'bold'  => true,
                
                'size'  => 13,
                'name'  => 'Verdana'
            ));
        // Add some data
        $objPHPExcel->setActiveSheetIndex(0);
        $objPHPExcel->getActiveSheet()->SetCellValue('A1', 'MODASA');
        $objPHPExcel->getActiveSheet()->getStyle('A1')->applyFromArray($styleArray);
        $objPHPExcel->getActiveSheet()->SetCellValue('C2', 'CERTIFICADOS POR VENCER');
        $objPHPExcel->getActiveSheet()->SetCellValue('A4', 'Cliente');
        $objPHPExcel->getActiveSheet()->getStyle('A4')->applyFromArray($styleArray);
        $objPHPExcel->getActiveSheet()->SetCellValue('B4', 'Fecha del certificado');
        $objPHPExcel->getActiveSheet()->getStyle('B4')->applyFromArray($styleArray);
        $objPHPExcel->getActiveSheet()->SetCellValue('C4', 'Producto');
        $objPHPExcel->getActiveSheet()->getStyle('C4')->applyFromArray($styleArray);
        $objPHPExcel->getActiveSheet()->SetCellValue('D4', 'Servicio');
        $objPHPExcel->getActiveSheet()->getStyle('D4')->applyFromArray($styleArray);
        $objPHPExcel->getActiveSheet()->SetCellValue('E4', 'Fecha de vencimiento');
        $objPHPExcel->getActiveSheet()->getStyle('E4')->applyFromArray($styleArray);

        $rowCount = 5; //new

        $parametro = $this->parametro_model->ListarParametros();
        $param = $parametro[1];
		$param = intval($param->sParValor);
        //$reportes = $this->reportes_model->Certificadosxvencer();
        $hoy = date("Y-m-d"); 
        $array = [];
        /*em 14-01-20 */
        foreach ($_SESSION['reportes'] as $r) {
  
                $array[] = $r;
                $objPHPExcel->getActiveSheet()->SetCellValue('A'.$rowCount, $r->sInsCliente);   
                $objPHPExcel->getActiveSheet()->SetCellValue('B'.$rowCount, $r->dInsFecha); 
                $objPHPExcel->getActiveSheet()->SetCellValue('C'.$rowCount, $r->sInsProducto); 
                $objPHPExcel->getActiveSheet()->SetCellValue('D'.$rowCount, $r->sInsProducto);   
                $objPHPExcel->getActiveSheet()->SetCellValue('E'.$rowCount, date('d-m-Y', strtotime($r->dInsFechaVencimiento)));   
                $rowCount++; 
        }
        foreach(range('A','G') as $columnID) { $objPHPExcel->getActiveSheet()->getColumnDimension($columnID) ->setAutoSize(true); }

        // Rename worksheet
        $objPHPExcel->getActiveSheet()->setTitle('Excel');

        // Set active sheet index to the first sheet, so Excel opens this as the first sheet
        $objPHPExcel->setActiveSheetIndex(0);
    
    
        // Redirect output to a client’s web browser (Excel5)
        header('Content-Type: application/vnd.ms-excel');
        header('Content-Disposition: attachment;filename="Export_Excel_'.date('Y-m-d').'.xls"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');
    
        // If you're serving to IE over SSL, then the following may be needed
        header ('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header ('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT'); // always modified
        header ('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header ('Pragma: public'); // HTTP/1.0
    
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');

        // Redirect output to a client’s web browser (Excel5) 

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5'); 
        $objWriter->save('php://output');
        exit;
    }

    /*em 14-01-2021 */ // envia correo solo por certificado
    public function enviarCorreo()
    {

            $Correo = $this->reportes_model->CorreosComercial();
                    
            $array_final = [];
            $array_final[] = $_POST['sCliCorreo'];

            foreach ($Correo as $c) {
                $correos = $c->sParValor;
                //$listacodarr[] = $sugd->sRepCodigo;
                $array_final[] = $c->sParValor;
            }
            
            $asunto = "INFORMACION  GRUPO ELECTROGENO";
            $mensaje = '<html>
                                    <head><meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
                                        <title>Mensaje de Confirmacion</title>
                                        <style type="text/css">
                                          
                                        </style>    
                                    </head>
                                    <body>
                                        <div class="content">
                                            <H4 style="color: #D80000;font-weight: bold;">Estimado(a) Cliente,  '. $_POST['sInsCliente'].' </H4>
                                                <p style="color: #494949; font-size: 16px;">
                                             Reciba un cordial saludo, actualmente el (los) siguiente(s) certificado(s), está(n) próximos a vencer.<br><br> <br>

                                                
                                             <table border="1" align="center" cellpadding="0" cellspacing="0" bordercolor="#A4A4A4" style="font-size:15px">
                                             <tr>
                                             </tr>
 
                                             <tr>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">CLIENTE </font></th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">FECHA DE CERTIFICADO</font></th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">PRODUCTO</th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">SERVICIO</th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">FECHA DE VENCIMIENTO</th>
                                             </tr>
                                            <tr>
                                                <td align="center"> <font size="1">'.  $_POST['sInsCliente']. ' </td>
                                                <td align="center"> <font size="1">'.  $_POST['dInsFecha']. '  </td>   
                                                <td align="center"> <font size="1">'.  $_POST['sInsProducto']. ' </td>
                                                <td align="center"><font size="1">'.  $_POST['sInsServicio']. ' </td>
                                                <td align="center"> <font size="1">'. date('d-m-Y', strtotime( $_POST['dInsFechaVencimiento'])).'  </td>   
                                            </tr>
                                            </table>
      
                                            <br>
                                             Saludos, <br><br>
                                             <img src="cid:adjunto"/><br><br>
                                        </div>
                                    </body>
                                </html>
                                ';
        
            $x = $this->reportes_model->EnviarCorreo($asunto, $array_final, $mensaje);
            var_dump($x);
             //echo '<script type="text/javascript">window.location="?c=Sugerencias&a=Index";</script>';
     
    }
/* em 18-01-2021   reportes masivos   ************************************************************* */
    //  envia correo masivo por cada certificado sin agrupar
    public function enviarCorreoMasivo()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $param = $parametro[1];
		$param = intval($param->sParValor);

    $reportes =  $_SESSION['reportes'] ; // $this->reportes_model->Certificadosxvencer(); 
    foreach ($reportes as $r) {
        $fin =  date('Y-m-d', strtotime($r->dInsFechaVencimiento)); 
        $inicio =  date('Y-m-d', strtotime($fin."- $param days")); 
        
        $hoy = date("Y-m-d"); 
        if ( $hoy >= $inicio   &&  $hoy <= $fin ){
                   
          
          if ($r->sCliCorreo != '' ||  $r->sCliCorreo != null){ 
            $Correo = $this->reportes_model->CorreosComercial();
                    
            $array_final = [];
            $array_final[] = $r->sCliCorreo;

            foreach ($Correo as $c) {
                $correos = $c->sParValor;
                //$listacodarr[] = $sugd->sRepCodigo;
                $array_final[] = $c->sParValor;
            }
            
            $asunto = "INFORMACION  GRUPO ELECTROGENO";
            $mensaje = '<html>
                                    <head><meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
                                        <title>Mensaje de Confirmacion</title>
                                        <style type="text/css">
                                          
                                        </style>    
                                    </head>
                                    <body>
                                        <div class="content">
                                            <H4 style="color: #D80000;font-weight: bold;">Estimado(a) Cliente,  '. $r->sInsCliente.' </H4>
                                                <p style="color: #494949; font-size: 16px;">
                                             Reciba un cordial saludo, actualmente el (los) siguiente(s) certificado(s), está(n) próximos a vencer.<br><br> <br>

                                                
                                             <table border="1" align="center" cellpadding="0" cellspacing="0" bordercolor="#A4A4A4" style="font-size:15px">
                                             <tr>
                                             </tr>
 
                                             <tr>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">CLIENTE </font></th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">FECHA DE CERTIFICADO</font></th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">PRODUCTO</th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">SERVICIO</th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">SEDE/PROYECTO</th>
                                                 <th width="100" BGCOLOR="#B2BABB"><font size="2">FECHA DE VENCIMIENTO</th>
                                             </tr>
                                            <tr>
                                                <td align="center"> <font size="1">'.  $r->sInsCliente. ' </td>
                                                <td align="center"> <font size="1">'.  $r->dInsFecha. '  </td>   
                                                <td align="center"> <font size="1">'.  $r->sInsProducto . ' </td>
                                                <td align="center"><font size="1">'.  $r->sInsServicio . ' </td>
                                                <td align="center"><font size="1">'.  $r->sSedeProyecto . ' </td>
                                                <td align="center"> <font size="1">'. date('d-m-Y', strtotime( $r->dInsFechaVencimiento)).'  </td>   
                                            </tr>
                                            </table>
                                            <br>
                                              
                                             Saludos, <br><br>
                                             <img src="cid:adjunto"/><br><br>
                                        </div>
                                    </body>
                                </html>
                                ';

            $x = $this->reportes_model->EnviarCorreo($asunto, $array_final, $mensaje);
            
             //echo '<script type="text/javascript">window.location="?c=Sugerencias&a=Index";</script>';
        
          } //endif si existe correo   
        }	// endif si esta vencids 
    } //end for
}

/*em 20-01-2021*/ // envia correo masico a los clientes   
public function enviarCorreoMasivoCliente()
{
    $parametro = $this->parametro_model->ListarParametros();
    $param = $parametro[1];
    $param = intval($param->sParValor);

$reportes =  $_SESSION['reportes'] ; // $this->reportes_model->Certificadosxvencer(); 
foreach ($reportes as $r) {
    $fin =  date('Y-m-d', strtotime($r->dInsFechaVencimiento)); 
    $inicio =  date('Y-m-d', strtotime($fin."- $param days")); 
    
    $hoy = date("Y-m-d"); 
    if ( $hoy >= $inicio   &&  $hoy <= $fin ){
      
      if ($r->sCliCorreo != '' ||  $r->sCliCorreo != null){ 
       
        $array_final = [];
        $array_final[] = $r->sCliCorreo;
 
        $asunto = "INFORMACION  GRUPO ELECTROGENO";
        $mensaje = '<html>
                                <head><meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
                                    <title>Mensaje de Confirmacion</title>
                                    <style type="text/css">
                                      
                                    </style>    
                                </head>
                                <body>
                                    <div class="content">
                                        <H4 style="color: #D80000;font-weight: bold;">Estimado(a) Cliente,  '. $r->sInsCliente.' </H4>
                                            <p style="color: #494949; font-size: 16px;">
                                         Reciba un cordial saludo, actualmente el (los) siguiente(s) certificado(s), está(n) próximos a vencer.<br><br> <br>

                                            
                                         <table border="1" align="center" cellpadding="0" cellspacing="0" bordercolor="#A4A4A4" style="font-size:15px">
                                         <tr>
                                         </tr>

                                         <tr>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">CLIENTE </font></th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">FECHA DE CERTIFICADO</font></th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">PRODUCTO</th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">SERVICIO</th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">SEDE/PROYECTO</th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">FECHA DE VENCIMIENTO</th>
                                         </tr>
                                        <tr>
                                            <td align="center"> <font size="1">'.  $r->sInsCliente. ' </td>
                                            <td align="center"> <font size="1">'.  $r->dInsFecha. '  </td>   
                                            <td align="center"> <font size="1">'.  $r->sInsProducto . ' </td>
                                            <td align="center"><font size="1">'.  $r->sInsServicio . ' </td>
                                            <td align="center"><font size="1">'.  $r->sSedeProyecto . ' </td>
                                            <td align="center"> <font size="1">'. date('d-m-Y', strtotime( $r->dInsFechaVencimiento)).'  </td>   
                                        </tr>
                                        </table>
                                        <br>
                                          
                                         Saludos, <br><br>
                                         <img src="cid:adjunto"/><br><br>
                                    </div>
                                </body>
                            </html>
                            ';

        $x = $this->reportes_model->EnviarCorreo($asunto, $array_final, $mensaje);
         
      } //endif si existe correo   
    }	// endif si esta vencids 
} //end for
}
/* em 21-01-2021*/ // envia correo masivo a modasa agrupado
public function enviarCorreoMasivoModasa()
{
    
    $this->enviarCorreoMasivoCliente();
    $parametro = $this->parametro_model->ListarParametros();
    $param = $parametro[1];
    $param = intval($param->sParValor);

    $reportes =  $_SESSION['reportes'] ; // $this->reportes_model->Certificadosxvencer(); 
                
        $Correo = $this->reportes_model->CorreosComercial();
                            
        foreach ($Correo as $c) {
            $array_final = [];
            $correos = $c->sParValor;
            //$listacodarr[] = $sugd->sRepCodigo;
            $array_final[0] = $c->sParValor;
                $c->Parametro_Id ==5 ? $destino = 'Planner' : $destino = 'Modasa';
                $asunto = "INFORMACION  GRUPO ELECTROGENO";
                $mensaje = "";
                $mensaje .='<html>
                                <head><meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
                                    <title>Mensaje de Confirmacion</title>
                                    <style type="text/css">
                                      
                                    </style>    
                                </head>
                                <body>
                                    <div class="content">
                                        <H4 style="color: #D80000;font-weight: bold;">Estimado(a) ,  '. $destino.' </H4>
                                            <p style="color: #494949; font-size: 16px;">
                                         Reciba un cordial saludo, actualmente el (los) siguiente(s) certificado(s), está(n) próximos a vencer.<br><br> <br>

                                            
                                         <table border="1" align="center" cellpadding="0" cellspacing="0" bordercolor="#A4A4A4" style="font-size:15px">
                                         <tr>
                                         </tr>

                                         <tr>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">CLIENTE </font></th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">FECHA DE CERTIFICADO</font></th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">PRODUCTO</th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">SERVICIO</th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">SEDE/PROYECTO</th>
                                             <th width="100" BGCOLOR="#B2BABB"><font size="2">FECHA DE VENCIMIENTO</th>
                                         </tr>';
                                        foreach ($reportes as $r) {
                                            $fin =  date('Y-m-d', strtotime($r->dInsFechaVencimiento)); 
                                            $inicio =  date('Y-m-d', strtotime($fin."- $param days")); 
                                            
                                            $hoy = date("Y-m-d"); 
                                        if ( $hoy >= $inicio   &&  $hoy <= $fin ){
                                               
                                            $mensaje .= '<tr>
                                            <td align="center"> <font size="1">'.  $r->sInsCliente. ' </td>
                                            <td align="center"> <font size="1">'.  $r->dInsFecha. '  </td>   
                                            <td align="center"> <font size="1">'.  $r->sInsProducto . ' </td>
                                            <td align="center"><font size="1">'.  $r->sInsServicio . ' </td>
                                            <td align="center"><font size="1">'.  $r->sSedeProyecto . ' </td>
                                            <td align="center"> <font size="1">'. date('d-m-Y', strtotime( $r->dInsFechaVencimiento)).'  </td>   
                                            </tr>';
                                        }
                                        } 
                                            $mensaje .='</table>
                                            <br>
                                         Saludos, <br><br>
                                         <img src="cid:adjunto"/><br><br>
                                    </div>
                                </body>
                            </html>
                            ';

                $x = $this->reportes_model->EnviarCorreo($asunto, $array_final , $mensaje);
                unset($array_final);
            }
 
}

}
