<?php

class MatrizModel
{
    private $pdo;

    public function __construct()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL matriz_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mat = new matriz();
                $mat->__SET('matriz_id', $r->matriz_id);
                $mat->__SET('Plantilla_Id', $r->Plantilla_Id);
                $mat->__SET('nMatHoras', $r->nMatHoras);
                $mat->__SET('nMatEliminado', $r->nMatEliminado);
                $mat->__SET('nMatUsuario_Id', $r->nMatUsuario_Id);
                $mat->__SET('sPlaNombre', $r->sPlaNombre);
                $mat->__SET('Tipo', $r->Tipo);
                $result[] = $mat;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function ListaFiltrada($nTipo)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL matriz_lista_filtrada(?)");
            $stm->execute([$nTipo]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mat = new matriz();
                $mat->__SET('matriz_id', $r->matriz_id);
                $mat->__SET('Plantilla_Id', $r->Plantilla_Id);
                $mat->__SET('nMatHoras', $r->nMatHoras);
                $mat->__SET('nMatEliminado', $r->nMatEliminado);
                $mat->__SET('nMatUsuario_Id', $r->nMatUsuario_Id);
                $mat->__SET('sPlaNombre', $r->sPlaNombre);
                $result[] = $mat;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }


    public function Buscar($matriz_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL matriz_listar($matriz_id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $mat = new matriz();
                $mat->__SET('matriz_id', $r->matriz_id);
                $mat->__SET('Plantilla_Id', $r->Plantilla_Id);
                $mat->__SET('nMatHoras', $r->nMatHoras);
                $mat->__SET('nMatEliminado', $r->nMatEliminado);
                $mat->__SET('nMatUsuario_Id', $r->nMatUsuario_Id);
                $mat->__SET('sPlaNombre', $r->sPlaNombre);
                $result[] = $mat;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Guardar(matriz $matriz)
    {
        try {
            $stm = $this->pdo->prepare("CALL matriz_crear(?,?,?,?)");
            $stm->execute(array(
                $matriz->__get('Plantilla_Id'),
                $matriz->__get('nMatHoras'),
                $matriz->__get('nMatEliminado'),
                $matriz->__get('nMatUsuario_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(matriz $matriz)
    {
        try {
            $stm = $this->pdo->prepare("CALL matriz_editar(?,?,?,?,?)");
            $stm->execute(array(
                $matriz->__get('matriz_id'),
                $matriz->__get('Plantilla_Id'),
                $matriz->__get('nMatHoras'),
                $matriz->__get('nMatEliminado'),
                $matriz->__get('nMatUsuario_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(matriz $matriz)
    {
        try {
            $stm = $this->pdo->prepare("CALL matriz_eliminar(?)");
            $stm->execute(array(
                $matriz->__get('matriz_id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}
