<?php

class TareaModel {
    private $pdo;

    public function __construct()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tar_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $tarea = new Tarea();
                $tarea->__set('Tarea_Id', $r->Tarea_Id);
                $tarea->__set('sTarCodigo', $r->sTarCodigo);
                $tarea->__set('sTarNombre', $r->sTarNombre);
                $tarea->__set('nTarEliminado', $r->nTarEliminado);
                $result[] = $tarea;
            }
            return $result;
            
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($Tarea_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tar_listar($Tarea_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $tarea = new Tarea();
                $tarea->__set('Tarea_Id', $r->Tarea_Id);
                $tarea->__set('sTarCodigo', $r->sTarCodigo);
                $tarea->__set('sTarNombre', $r->sTarNombre);
                $tarea->__set('nTarEliminado', $r->nTarEliminado);
                $result[] = $tarea;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Guardar(Tarea $tarea)
    {
        try {
            $Tarea_Id = 0;
            $stm = $this->pdo->prepare("CALL tar_crear(?,?,?,@Tarea_Id)");
            $stm->execute(array(
                $tarea->__get('sTarCodigo'),
                $tarea->__get('sTarNombre'),
                $tarea->__get('nTarUsuario_Id')
            ));
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $Tarea_Id = $r->Tarea_Id;
            endforeach;
            return $Tarea_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(Tarea $tarea)
    {
        try {
            $stm = $this->pdo->prepare("CALL tar_editar(?,?,?,?)");
            $stm->execute(array(
                $tarea->__get('sTarCodigo'),
                $tarea->__get('sTarNombre'),
                $tarea->__get('Tarea_Id'),
                $tarea->__get('nTarUsuario_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(Tarea $tarea)
    {
        try {
            $stm = $this->pdo->prepare("CALL tar_eliminar(?)");
            $stm->execute(array(
                $tarea->__get('Tarea_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function CrearTareaSistemaDetalle(TareaSistemaDetalle $tsd) {
        try {
            $stm = $this->pdo->prepare("CALL ts_crear(?,?)");
            $stm->execute(array(
                $tsd->__get('nTSTarea_Id'),
                $tsd->__get('nTSSistema_Id'),
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EliminarTareaSistema($Tarea_Id) {
        try {
            $stm = $this->pdo->prepare("CALL ts_eliminar($Tarea_Id)");
            $stm->execute();
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function ListarTSPorTarea($Tarea_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ts_listar_por_tarea($Tarea_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $result[] = $r;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}